package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRArchivesBorrow;
import cn.ibizlab.humanresource.core.humanresource.filter.HRArchivesBorrowSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRArchivesBorrow] 服务对象接口
 */
public interface IHRArchivesBorrowService extends IService<HRArchivesBorrow>{

    boolean create(HRArchivesBorrow et) ;
    void createBatch(List<HRArchivesBorrow> list) ;
    boolean update(HRArchivesBorrow et) ;
    void updateBatch(List<HRArchivesBorrow> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRArchivesBorrow get(String key) ;
    HRArchivesBorrow getDraft(HRArchivesBorrow et) ;
    boolean checkKey(HRArchivesBorrow et) ;
    boolean save(HRArchivesBorrow et) ;
    void saveBatch(List<HRArchivesBorrow> list) ;
    Page<HRArchivesBorrow> searchDefault(HRArchivesBorrowSearchContext context) ;
    List<HRArchivesBorrow> selectByHrarchivesid(String hrarchivesid) ;
    void removeByHrarchivesid(String hrarchivesid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRArchivesBorrow> getHrarchivesborrowByIds(List<String> ids) ;
    List<HRArchivesBorrow> getHrarchivesborrowByEntities(List<HRArchivesBorrow> entities) ;
}


